<template>
  <QuickNav selected="Home"></QuickNav>
  <TopMessage />

  <!-- CONTENT -->
  <section id="Content" class="p-6 pb-24">
    <h1 id="ViewHeading" class="text-4xl text-center font-light pt-4 mb-8">
      Time Safari
    </h1>

    <!-- show the actions for recognizing a give -->
    <div class="mb-8">
      <div
        v-if="!activeDid"
        class="bg-amber-200 rounded-md overflow-hidden text-center px-4 py-3 mb-4"
      >
        <p class="text-lg mb-3">
          You need an <b>identifier</b> before you can record anyone's gives.
        </p>
        <router-link
          :to="{ name: 'start' }"
          class="block text-center text-md font-bold uppercase bg-blue-500 text-white mt-2 px-2 py-3 rounded-md"
        >
          Create Your Identifier</router-link
        >
      </div>

      <div
        v-else-if="!isRegistered"
        class="bg-amber-200 rounded-md overflow-hidden text-center px-4 py-3 mb-4"
      >
        Someone must register your account before you can record anyone's gives.
        To do this:
        <router-link
          :to="{ name: 'contact-qr' }"
          class="block text-center text-md font-bold uppercase bg-blue-500 text-white mt-2 px-2 py-3 rounded-md"
        >
          1. Show Them Your Identity Info</router-link
        >
        <router-link
          :to="{ name: 'account' }"
          class="block text-center text-md font-bold uppercase bg-blue-500 text-white mt-2 px-2 py-3 rounded-md"
        >
          2. Check Your Limits</router-link
        >
      </div>

      <div v-else>
        <!-- activeDid && isRegistered -->
        <h2 class="text-xl font-bold mb-4">Record Something Given</h2>

        <ul class="grid grid-cols-4 gap-x-3 gap-y-5 text-center mb-5">
          <li @click="openDialog()">
            <EntityIcon
              :entityId="null"
              :iconSize="64"
              class="mx-auto border border-slate-300 rounded-md mb-1"
            ></EntityIcon>
            <h3
              class="text-xs italic font-medium text-ellipsis whitespace-nowrap overflow-hidden"
            >
              Anonymous/Unnamed
            </h3>
          </li>
          <li
            v-for="contact in allContacts"
            :key="contact.did"
            @click="openDialog(contact)"
          >
            <EntityIcon
              :entityId="contact.did"
              :iconSize="64"
              class="mx-auto border border-slate-300 rounded-md mb-1"
            ></EntityIcon>
            <h3
              class="text-xs font-medium text-ellipsis whitespace-nowrap overflow-hidden"
            >
              {{ contact.name || contact.did }}
            </h3>
          </li>
        </ul>

        <!-- Ideally, this button should only be visible when the active account has more than 7 or 11 contacts in their list (we want to limit the grid count above to 8 or 12 accounts to keep it compact) -->
        <router-link
          v-if="allContacts.length >= 7"
          :to="{ name: 'contact-gives' }"
          class="block text-center text-md font-bold uppercase bg-slate-500 text-white px-2 py-3 rounded-md"
        >
          Show More Contacts&hellip;
        </router-link>

        <!-- If there are no contacts, show this instead: -->
        <div
          class="rounded border border-dashed border-slate-300 bg-slate-100 px-4 py-3 text-center italic text-slate-500"
          v-if="allContacts.length === 0"
        >
          (No contacts to show.)
        </div>
      </div>
    </div>

    <GiftedDialog
      ref="customDialog"
      message="Received from"
      showGivenToUser="true"
    />

    <!-- Results List -->
    <div class="bg-slate-100 rounded-md overflow-hidden px-4 py-3 mb-4">
      <h2 class="text-xl font-bold mb-4">Latest Activity</h2>
      <InfiniteScroll @reached-bottom="loadMoreGives">
        <ul class="border-t border-slate-300">
          <li
            class="border-b border-slate-300 py-2"
            v-for="record in feedData"
            :key="record.jwtId"
          >
            <div
              class="border-b border-dashed border-slate-400 text-orange-400 pb-2 mb-2 font-bold uppercase text-sm"
              v-if="record.jwtId == feedLastViewedClaimId"
            >
              You've seen all the following
            </div>

            <div class="flex">
              <fa icon="gift" class="pt-1 pr-2 text-slate-500"></fa>
              <span class="">{{ this.giveDescription(record) }}</span>
              <a @click="onClickLoadClaim(record.jwtId)">
                <fa icon="circle-info" class="pl-2 pt-1 text-slate-500"></fa>
              </a>
            </div>
          </li>
        </ul>
      </InfiniteScroll>
      <div :class="{ hidden: isHiddenSpinner }">
        <p class="text-slate-500 text-center italic mt-4 mb-4">
          <fa icon="spinner" class="fa-spin-pulse"></fa> Loading&hellip;
        </p>
      </div>
    </div>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from "vue-facing-decorator";

import EntityIcon from "@/components/EntityIcon.vue";
import GiftedDialog from "@/components/GiftedDialog.vue";
import InfiniteScroll from "@/components/InfiniteScroll.vue";
import QuickNav from "@/components/QuickNav.vue";
import TopMessage from "@/components/TopMessage.vue";
import { db, accountsDB } from "@/db/index";
import { Account } from "@/db/tables/accounts";
import { Contact } from "@/db/tables/contacts";
import { MASTER_SETTINGS_KEY, Settings } from "@/db/tables/settings";
import { accessToken } from "@/libs/crypto";
import {
  didInfo,
  GiverInputInfo,
  GiveServerRecord,
} from "@/libs/endorserServer";
import { IIdentifier } from "@veramo/core";

interface Notification {
  group: string;
  type: string;
  title: string;
  text: string;
}

@Component({
  components: {
    GiftedDialog,
    QuickNav,
    EntityIcon,
    InfiniteScroll,
    TopMessage,
  },
})
export default class HomeView extends Vue {
  $notify!: (notification: Notification, timeout?: number) => void;

  activeDid = "";
  allContacts: Array<Contact> = [];
  allMyDids: Array<string> = [];
  apiServer = "";
  feedData = [];
  feedPreviousOldestId?: string;
  feedLastViewedClaimId?: string;
  isHiddenSpinner = true;
  isRegistered = false;
  numAccounts = 0;

  async beforeCreate() {
    await accountsDB.open();
    this.numAccounts = await accountsDB.accounts.count();
  }

  public async getIdentity(activeDid: string) {
    await accountsDB.open();
    const account = (await accountsDB.accounts
      .where("did")
      .equals(activeDid)
      .first()) as Account;
    const identity = JSON.parse(account?.identity || "null");
    return identity; // may be null
  }

  public async getHeaders(identity: IIdentifier) {
    const token = await accessToken(identity);
    const headers = {
      "Content-Type": "application/json",
      Authorization: "Bearer " + token,
    };
    return headers;
  }

  async created() {
    try {
      await accountsDB.open();
      const allAccounts = await accountsDB.accounts.toArray();
      this.allMyDids = allAccounts.map((acc) => acc.did);

      await db.open();
      const settings = (await db.settings.get(MASTER_SETTINGS_KEY)) as Settings;
      this.apiServer = settings?.apiServer || "";
      this.activeDid = settings?.activeDid || "";
      this.allContacts = await db.contacts.toArray();
      this.feedLastViewedClaimId = settings?.lastViewedClaimId;
      this.isRegistered = !!settings?.isRegistered;

      // this returns a Promise but we don't need to wait for it
      this.updateAllFeed();

      // eslint-disable-next-line @typescript-eslint/no-explicit-any
    } catch (err: any) {
      this.$notify(
        {
          group: "alert",
          type: "danger",
          title: "Error",
          text:
            err.userMessage ||
            "There was an error retrieving the latest sweet, sweet action.",
        },
        -1,
      );
    }
  }

  public async buildHeaders() {
    const headers: HeadersInit = {
      "Content-Type": "application/json",
    };

    if (this.activeDid) {
      await accountsDB.open();
      const allAccounts = await accountsDB.accounts.toArray();
      const account = allAccounts.find(
        (acc) => acc.did === this.activeDid,
      ) as Account;
      const identity = JSON.parse(account?.identity || "null");

      if (!identity) {
        throw new Error(
          "An ID is chosen but there are no keys for it so it cannot be used to talk with the service.",
        );
      }

      headers["Authorization"] = "Bearer " + (await accessToken(identity));
    } else {
      // it's OK without auth... we just won't get any identifiers
    }
    return headers;
  }

  /**
   * Data loader used by infinite scroller
   * @param payload is the flag from the InfiniteScroll indicating if it should load
   **/
  public async loadMoreGives(payload: boolean) {
    if (payload) {
      this.updateAllFeed();
    }
  }

  public async updateAllFeed() {
    this.isHiddenSpinner = false;
    await this.retrieveGives(this.apiServer, this.feedPreviousOldestId)
      .then(async (results) => {
        if (results.data.length > 0) {
          this.feedData = this.feedData.concat(results.data);
          this.feedPreviousOldestId =
            results.data[results.data.length - 1].jwtId;
          // The following update is only done on the first load.
          if (
            this.feedLastViewedClaimId == null ||
            this.feedLastViewedClaimId < results.data[0].jwtId
          ) {
            await db.open();
            db.settings.update(MASTER_SETTINGS_KEY, {
              lastViewedClaimId: results.data[0].jwtId,
            });
          }
        }
      })
      .catch((e) => {
        console.log("Error with feed load:", e);
        this.$notify(
          {
            group: "alert",
            type: "danger",
            title: "Feed Error",
            text: e.userMessage || "There was an error retrieving feed data.",
          },
          -1,
        );
      });
    this.isHiddenSpinner = true;
  }

  /**
   * Retrieve claims in reverse chronological order
   *
   * @param beforeId the earliest ID (of previous searches) to search earlier
   * @return claims in reverse chronological order
   */
  public async retrieveGives(endorserApiServer: string, beforeId?: string) {
    const beforeQuery = beforeId == null ? "" : "&beforeId=" + beforeId;
    const response = await fetch(
      endorserApiServer + "/api/v2/report/gives?" + beforeQuery,
      {
        method: "GET",
        headers: await this.buildHeaders(),
      },
    );

    if (response.status !== 200) {
      throw await response.text();
    }

    const results = await response.json();

    if (results.data) {
      return results;
    } else {
      throw JSON.stringify(results);
    }
  }

  giveDescription(giveRecord: GiveServerRecord) {
    // similar code is in endorser-mobile utility.ts
    // claim.claim happen for some claims wrapped in a Verifiable Credential
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const claim = (giveRecord.fullClaim as any).claim || giveRecord.fullClaim;
    // agent.did is for legacy data, before March 2023
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const giverDid = claim.agent?.identifier || (claim.agent as any)?.did;
    const giverInfo = didInfo(
      giverDid,
      this.activeDid,
      this.allMyDids,
      this.allContacts,
    );
    let gaveAmount = claim.object?.amountOfThisGood
      ? this.displayAmount(claim.object.unitCode, claim.object.amountOfThisGood)
      : "";
    if (claim.description) {
      if (gaveAmount) {
        gaveAmount = gaveAmount + ", and also: ";
      }
      gaveAmount = gaveAmount + claim.description;
    }
    if (!gaveAmount) {
      gaveAmount = "something not described";
    }
    // recipient.did is for legacy data, before March 2023
    const gaveRecipientId =
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      claim.recipient?.identifier || (claim.recipient as any)?.did;
    const gaveRecipientInfo = gaveRecipientId
      ? " to " +
        didInfo(
          gaveRecipientId,
          this.activeDid,
          this.allMyDids,
          this.allContacts,
        )
      : "";
    return giverInfo + " gave" + gaveRecipientInfo + ": " + gaveAmount;
  }

  onClickLoadClaim(jwtId: string) {
    const route = {
      path: "/claim/" + encodeURIComponent(jwtId),
    };
    this.$router.push(route);
  }

  displayAmount(code: string, amt: number) {
    return "" + amt + " " + this.currencyShortWordForCode(code, amt === 1);
  }

  currencyShortWordForCode(unitCode: string, single: boolean) {
    return unitCode === "HUR" ? (single ? "hour" : "hours") : unitCode;
  }

  openDialog(giver: GiverInputInfo) {
    (this.$refs.customDialog as GiftedDialog).open(giver);
  }
}
</script>
